---
title: Introduction and Statement of Principles  
---

# introduction and statement of principles

## this help { id="this_help" }

Click the links on the left to go through the getting started guide. Subheadings are on the right. Larger sections are up top. Please at least skim every page in the getting started section, as this will introduce you to the main systems in the client. There is a lot, so you do not have to do it all in one go.

The section on installing, updating, and **backing up** is very important.

This help is available locally in every release. Hit `help->help and getting started guide` in the client, or open `install_dir/help/index.html`.

## on having too many files { id="files" }

I've been on the internet and imageboards for a <span style="color:red">lo</span><span style="color:green">ng</span> time, saving everything I like to my hard drive. After a while, the whole collection was just too large to manage on my own. I couldn't find anything in the mess, and I just saved new files in there with names like 'image1257.jpg'.

There aren't many solutions to this problem that aren't online, and I didn't want to lose my privacy or control.

## on being anonymous { id="anonymous" }

I enjoy being anonymous online. When you aren't afraid of repercussions, you can be as truthful as you want and share interesting things, no matter how unusual. You can have unique conversations and tackle some otherwise unsolvable problems. It's fun!

I'm a normal Anon, nothing special. :^)

## the hydrus network { id="hydrus_network" }

So! I'm developing a program that helps people organise their files on their own terms and, if they want to, collaborate with others anonymously. I want to help you do what you want with your stuff, and that's it. You can share some tags (and files, but this is limited) with other people if you want to, but you don't have to connect to anything if you don't. **The default is complete privacy, no sharing**, and every upload requires a conscious action on your part. I don't plan to ever record metrics on users, nor serve ads, nor charge for my software. The software never phones home.

This does a lot more than a normal image viewer. If you are totally new to the idea of personal media collections and booru-style tagging, I suggest you start slow, walk through the getting started guides, and experiment doing different things. If you aren't sure on what a button does, try clicking it! You'll be importing thousands of files and applying _tens_ of thousands of tags in no time. The best way to learn is just to try things out.

The client is chiefly a file database. It stores your files inside its own folders, managing them far better than an explorer window or some online gallery. Here's a screenshot of one of my test installs with a search showing all files:

[![](images/example_client.png "WELCOME TO INTERNET")](images/example_client.png)

As well as the client, there is also a server that anyone can run to store files or tags for sharing between many users. This is advanced, and almost always confusing to new users, do not explore this until you know what you are doing. There is however, a user-run **public tag repository**, with more than a billion tags, that you can access and contribute to if you wish.

I have many plans to expand the client and the network.

## statement of principles { id="principles" }

*   Speech should be as free as possible.
*   Everyone should be able to control their own media diet.
*   Computer data and network logs should be absolutely private.

None of the above are currently true, but I would love to live in a world where they were. My software is an attempt to move us a little closer.

Where possible, I prefer decentralised systems that are focused on people. I still use gmail and youtube IRL just like pretty much everyone, but I would rather we have alternative systems for alternate work, especially in the future. No one seemed to be making what I wanted for file management, particularly as everything rushed to the cloud space, so I decided to make a local solution myself, and here we are.

If, after a few months, you find you enjoy the software and would like to further support it, I have set up a simple no-reward patreon, which you can read more about [here](support.md).

## license

These programs are free software. Everything I, hydrus dev, have made is under the Do What The Fuck You Want To Public License, Version 3, [as published](https://github.com/sirkris/WTFPL/blob/master/WTFPL.md) by Kris Craig.

``` title="license.txt"
--8<-- "license.txt"
```

Do what the fuck you want to with my software, and if shit breaks, DEAL WITH IT.
